diff --git a/gcc/java/class.c b/gcc/java/class.c
index bbe7c86..d2946b8 100644
--- a/gcc/java/class.c
+++ b/gcc/java/class.c
@@ -208,7 +208,7 @@ add_assume_compiled (const char *ident, int excludep)
 
 /* The default value returned by enable_assertions. */
 
-#define DEFAULT_ENABLE_ASSERT (optimize == 0)
+#define DEFAULT_ENABLE_ASSERT (GCC_OPTION (optimize) == 0)
 
 /* Enter IDENT (a class or package name) into the enable-assertions table.
    VALUE is true to enable and false to disable. */
@@ -470,7 +470,7 @@ gen_indirect_dispatch_tables (tree type)
     pushdecl (TYPE_CTABLE_DECL (type));  
   }
 
-  if (flag_indirect_dispatch)
+  if (GCC_OPTION (flag_indirect_dispatch))
     {
       GEN_TABLE (ATABLE, _atable, atable_type, type);
       GEN_TABLE (OTABLE, _otable, otable_type, type);
@@ -872,7 +872,7 @@ add_field (tree klass, tree name, tree field_type, int flags)
 	 that native methods can always access the field.  */
       TREE_PUBLIC (field) = 1;
       /* Hide everything that shouldn't be visible outside a DSO.  */
-      if (flag_indirect_classes
+      if (GCC_OPTION (flag_indirect_classes)
 	  || (FIELD_PRIVATE (field)))
 	java_hide_decl (field);
       /* Considered external unless we are compiling it into this
@@ -985,7 +985,7 @@ build_utf8_ref (tree name)
       int decl_size;
       /* Ensure decl_size is a multiple of utf8const_type's alignment. */
       decl_size = name_len + 4 + name_pad;
-      if (flag_merge_constants && decl_size < 256)
+      if (GCC_OPTION (flag_merge_constants) && decl_size < 256)
 	{
 	  char buf[32];
 	  int flags = (SECTION_OVERRIDE
@@ -1033,7 +1033,7 @@ build_static_class_ref (tree type)
     {
       decl = build_decl (input_location, VAR_DECL, decl_name, class_type_node);
       TREE_STATIC (decl) = 1;
-      if (! flag_indirect_classes)
+      if (! GCC_OPTION (flag_indirect_classes))
 	{
 	  TREE_PUBLIC (decl) = 1;
 	  if (CLASS_PRIVATE (TYPE_NAME (type)))
@@ -1094,10 +1094,10 @@ build_classdollar_field (tree type)
 void
 cache_this_class_ref (tree fndecl)
 {
-  if (optimize)
+  if (GCC_OPTION (optimize))
     {
       tree classdollar_field;
-      if (flag_indirect_classes)
+      if (GCC_OPTION (flag_indirect_classes))
 	classdollar_field = build_classdollar_field (output_class);
       else
 	classdollar_field = build_static_class_ref (output_class);
@@ -1149,12 +1149,12 @@ build_class_ref (tree type)
       if (TREE_CODE (type) == POINTER_TYPE)
 	type = TREE_TYPE (type);
 
-      if (flag_indirect_dispatch
+      if (GCC_OPTION (flag_indirect_dispatch)
 	  && type != output_class
 	  && TREE_CODE (type) == RECORD_TYPE)
 	return build_indirect_class_ref (type);
 
-      if (type == output_class && flag_indirect_classes)
+      if (type == output_class && GCC_OPTION (flag_indirect_classes))
 	{
 	  /* This can be NULL if we see a JNI stub before we see any
 	     other method.  */
@@ -1234,7 +1234,7 @@ build_static_field_ref (tree fdecl)
      -findirect-dispatch, we simply never do this folding if compiling
      from .class; in the .class file constants will be referred to via
      the constant pool.  */
-  if (!flag_indirect_dispatch
+  if (!GCC_OPTION (flag_indirect_dispatch)
       && (is_compiled
 	  || (FIELD_FINAL (fdecl) && DECL_INITIAL (fdecl) != NULL_TREE
 	      && (JSTRING_TYPE_P (TREE_TYPE (fdecl))
@@ -1406,7 +1406,7 @@ make_local_function_alias (tree method)
   DECL_INITIAL (alias) = error_mark_node;
   TREE_ADDRESSABLE (alias) = 1;
   TREE_USED (alias) = 1;
-  if (!flag_syntax_only)
+  if (!GCC_OPTION (flag_syntax_only))
     assemble_alias (alias, DECL_ASSEMBLER_NAME (method));
   return alias;
 #else
@@ -1422,7 +1422,7 @@ make_field_value (tree fdecl)
   tree finit;
   int flags;
   tree type = TREE_TYPE (fdecl);
-  int resolved = is_compiled_class (type) && ! flag_indirect_dispatch;
+  int resolved = is_compiled_class (type) && ! GCC_OPTION (flag_indirect_dispatch);
   vec<constructor_elt, va_gc> *v = NULL;
 
   START_RECORD_CONSTRUCTOR (v, field_type_node);
@@ -1449,7 +1449,7 @@ make_field_value (tree fdecl)
   {
     tree field_address = integer_zero_node;
     tree index, value;
-    if ((DECL_INITIAL (fdecl) || ! flag_indirect_classes) 
+    if ((DECL_INITIAL (fdecl) || ! GCC_OPTION (flag_indirect_classes)) 
 	&& FIELD_STATIC (fdecl))
       field_address = build_address_of (fdecl);
 
@@ -1488,7 +1488,7 @@ make_method_value (tree mdecl)
   if (CLASS_INTERFACE (TYPE_NAME (class_decl)))
     index = build_int_cst (NULL_TREE,
 			   get_interface_method_index (mdecl, class_decl));
-  else if (!flag_indirect_dispatch && get_method_index (mdecl) != NULL_TREE)
+  else if (!GCC_OPTION (flag_indirect_dispatch) && get_method_index (mdecl) != NULL_TREE)
     index = get_method_index (mdecl);
   else
     index = integer_minus_one_node;
@@ -1798,7 +1798,7 @@ make_class_data (tree type)
   decl = TREE_OPERAND (this_class_addr, 0);
 
   if (supers_all_compiled (type) && ! CLASS_INTERFACE (type_decl)
-      && !flag_indirect_dispatch)
+      && !GCC_OPTION (flag_indirect_dispatch))
     {
       tree dtable = get_dispatch_table (type, this_class_addr);
       uses_jv_markobj = uses_jv_markobj_p (dtable);
@@ -1823,7 +1823,7 @@ make_class_data (tree type)
 	 table for java.lang.Class.  */
       if (DECL_NAME (type_decl) != id_class)
 	java_hide_decl (dtable_decl);
-      if (! flag_indirect_classes)
+      if (! GCC_OPTION (flag_indirect_classes))
 	rest_of_decl_compilation (dtable_decl, 1, 0);
       /* Maybe we're compiling Class as the first class.  If so, set
 	 class_dtable_decl to the decl we just made.  */
@@ -1846,7 +1846,7 @@ make_class_data (tree type)
 	{
 	  if (FIELD_STATIC (field))
 	    static_field_count++;
-	  else if (uses_jv_markobj || !flag_reduced_reflection)
+	  else if (uses_jv_markobj || !GCC_OPTION (flag_reduced_reflection))
 	    instance_field_count++;
 	}
     }
@@ -1876,7 +1876,7 @@ make_class_data (tree type)
 	  field_index = 0;
 	  if (FIELD_STATIC (field))
 	    field_index = static_count++;
-	  else if (uses_jv_markobj || !flag_reduced_reflection)
+	  else if (uses_jv_markobj || !GCC_OPTION (flag_reduced_reflection))
 	    field_index = instance_count++;
 	  else
 	    continue;
@@ -1905,7 +1905,7 @@ make_class_data (tree type)
 	      rest_of_decl_compilation (field, 1, 1);
 	      DECL_INITIAL (field) = initial;
 	    }
-	  else if (uses_jv_markobj || !flag_reduced_reflection)
+	  else if (uses_jv_markobj || !GCC_OPTION (flag_reduced_reflection))
 	    {
               tree init = make_field_value (field);
               CONSTRUCTOR_APPEND_ELT (instance_fields, NULL_TREE, init);
@@ -1939,8 +1939,8 @@ make_class_data (tree type)
     {
       tree init;
       if (METHOD_PRIVATE (method)
-	  && ! flag_keep_inline_functions
-	  && optimize)
+	  && ! GCC_OPTION (flag_keep_inline_functions)
+	  && GCC_OPTION (optimize))
 	continue;
       /* Even if we have a decl, we don't necessarily have the code.
 	 This can happen if we inherit a method from a superclass for
@@ -1965,7 +1965,7 @@ make_class_data (tree type)
           - public not static -- It is potentially part of an
             interface.  The runtime uses reflection data to build
             interface dispatch tables.  */
-      if (!flag_reduced_reflection
+      if (!GCC_OPTION (flag_reduced_reflection)
           || DECL_CLINIT_P (method)
           || DECL_NAME (type_decl) == id_class
           || DECL_NAME (method) == id_main
@@ -2002,7 +2002,7 @@ make_class_data (tree type)
   super = CLASSTYPE_SUPER (type);
   if (super == NULL_TREE)
     super = null_pointer_node;
-  else if (! flag_indirect_dispatch
+  else if (! GCC_OPTION (flag_indirect_dispatch)
 	   && assume_compiled (IDENTIFIER_POINTER (DECL_NAME (type_decl)))
 	   && assume_compiled (IDENTIFIER_POINTER (DECL_NAME (TYPE_NAME (super)))))
     super = build_class_ref (super);
@@ -2033,7 +2033,7 @@ make_class_data (tree type)
 	  tree child = BINFO_BASE_BINFO (TYPE_BINFO (type), i);
 	  tree iclass = BINFO_TYPE (child);
 	  tree index;
-	  if (! flag_indirect_dispatch
+	  if (! GCC_OPTION (flag_indirect_dispatch)
 	      && (assume_compiled 
 		  (IDENTIFIER_POINTER (DECL_NAME (TYPE_NAME (iclass))))))
 	    index = build_class_ref (iclass);
@@ -2054,7 +2054,7 @@ make_class_data (tree type)
 
   constant_pool_constructor = build_constants_constructor ();
 
-  if (flag_indirect_dispatch)
+  if (GCC_OPTION (flag_indirect_dispatch))
     {
       TYPE_OTABLE_DECL (type) 
 	= emit_symbol_table 
@@ -2079,13 +2079,13 @@ make_class_data (tree type)
 
   START_RECORD_CONSTRUCTOR (v1, object_type_node);
   PUSH_FIELD_VALUE (v1, "vtable",
-		    (flag_indirect_classes 
+		    (GCC_OPTION (flag_indirect_classes) 
 		     ? null_pointer_node
 		     : fold_build_pointer_plus
 			 (build1 (ADDR_EXPR, dtable_ptr_type,
 				  class_dtable_decl),
 			  dtable_start_offset)));
-  if (! flag_hash_synchronization)
+  if (! GCC_OPTION (flag_hash_synchronization))
     PUSH_FIELD_VALUE (v1, "sync_info", null_pointer_node);
   FINISH_RECORD_CONSTRUCTOR (temp, v1, object_type_node);
   START_RECORD_CONSTRUCTOR (v2, class_type_node);
@@ -2106,7 +2106,7 @@ make_class_data (tree type)
 		    build_int_cst (NULL_TREE, method_count));
 
   PUSH_FIELD_VALUE (v2, "vtable_method_count",
-                    (flag_indirect_dispatch
+                    (GCC_OPTION (flag_indirect_dispatch)
                      ? integer_minus_one_node
                      : TYPE_NVIRTUALS (type)));
     
@@ -2116,7 +2116,7 @@ make_class_data (tree type)
   /* If we're using the binary compatibility ABI we don't know the
      size until load time.  */
   PUSH_FIELD_VALUE (v2, "size_in_bytes", 
-		    (flag_indirect_dispatch 
+		    (GCC_OPTION (flag_indirect_dispatch) 
 		     ? integer_minus_one_node 
 		     : size_in_bytes (type)));
   PUSH_FIELD_VALUE (v2, "field_count", 
@@ -2125,7 +2125,7 @@ make_class_data (tree type)
 		    build_int_cst (NULL_TREE, static_field_count));
 
   PUSH_FIELD_VALUE (v2, "vtable",
-                    (flag_indirect_dispatch || dtable_decl == NULL_TREE
+                    (GCC_OPTION (flag_indirect_dispatch) || dtable_decl == NULL_TREE
                      ? null_pointer_node
                      : fold_build_pointer_plus
 			 (build1 (ADDR_EXPR, dtable_ptr_type,
@@ -2225,10 +2225,10 @@ make_class_data (tree type)
   DECL_INITIAL (decl) = cons;
   
   /* Hash synchronization requires at least 64-bit alignment. */
-  if (flag_hash_synchronization && POINTER_SIZE < 64)
+  if (GCC_OPTION (flag_hash_synchronization) && POINTER_SIZE < 64)
     DECL_ALIGN (decl) = 64; 
   
-  if (flag_indirect_classes)
+  if (GCC_OPTION (flag_indirect_classes))
     {
       TREE_READONLY (decl) = 1;
       TREE_CONSTANT (DECL_INITIAL (decl)) = 1;
@@ -2238,7 +2238,7 @@ make_class_data (tree type)
   
   {
     tree classdollar_field = build_classdollar_field (type);
-    if (!flag_indirect_classes)
+    if (!GCC_OPTION (flag_indirect_classes))
       DECL_INITIAL (classdollar_field) = build_static_class_ref (type);
     rest_of_decl_compilation (classdollar_field, 1, 0);
   }
@@ -2592,7 +2592,7 @@ layout_class_methods (tree this_class)
     dtable_count = integer_zero_node;
 
   type_name = TYPE_NAME (this_class);
-  if (!flag_indirect_dispatch
+  if (!GCC_OPTION (flag_indirect_dispatch)
       && (CLASS_ABSTRACT (type_name) || CLASS_INTERFACE (type_name)))
     {
       /* An abstract class can have methods which are declared only in
@@ -2642,7 +2642,7 @@ layout_class_method (tree this_class, tree super_class,
 
   TREE_PUBLIC (method_decl) = 1;
 
-  if (flag_indirect_classes
+  if (GCC_OPTION (flag_indirect_classes)
       || (METHOD_PRIVATE (method_decl) && METHOD_STATIC (method_decl)
 	  && ! METHOD_NATIVE (method_decl)
 	  && ! special_method_p (method_decl)))
@@ -2693,7 +2693,7 @@ layout_class_method (tree this_class, tree super_class,
 	  tree method_index = get_method_index (super_method);
 	  set_method_index (method_decl, method_index);
 	  if (method_index == NULL_TREE 
-	      && ! flag_indirect_dispatch
+	      && ! GCC_OPTION (flag_indirect_dispatch)
 	      && ! DECL_ARTIFICIAL (super_method))
 	    error ("non-static method %q+D overrides static method",
                    method_decl);
@@ -2728,7 +2728,7 @@ register_class (void)
   if (!registered_class)
     vec_alloc (registered_class, 8);
 
-  if (flag_indirect_classes)
+  if (GCC_OPTION (flag_indirect_classes))
     node = current_class;
   else
     node = TREE_OPERAND (build_class_ref (current_class), 0);
@@ -2872,7 +2872,7 @@ emit_register_classes (tree *list_p)
     return;
 
   /* By default, generate instances of Class at runtime.  */
-  if (flag_indirect_classes)
+  if (GCC_OPTION (flag_indirect_classes))
     emit_indirect_register_classes (list_p);
   /* TARGET_USE_JCR_SECTION defaults to 1 if SUPPORTS_WEAK and
      TARGET_ASM_NAMED_SECTION, else 0.  Some targets meet those conditions
diff --git a/gcc/java/constants.c b/gcc/java/constants.c
index 7e9cf2e..cd9580c 100644
--- a/gcc/java/constants.c
+++ b/gcc/java/constants.c
@@ -486,7 +486,7 @@ build_ref_from_constant_pool (int index)
   tree d = TYPE_CPOOL_DATA_REF (output_class);
 
   if (d == NULL_TREE)
-    d = build_constant_data_ref (flag_indirect_classes);
+    d = build_constant_data_ref (GCC_OPTION (flag_indirect_classes));
 
   i = build_int_cst (NULL_TREE, index);
   d = build4 (ARRAY_REF, TREE_TYPE (TREE_TYPE (d)), d, i,
diff --git a/gcc/java/decl.c b/gcc/java/decl.c
index 53d6f89..8da917e 100644
--- a/gcc/java/decl.c
+++ b/gcc/java/decl.c
@@ -535,7 +535,7 @@ parse_version (void)
       ++p;
     }
 
-  if (flag_indirect_dispatch)
+  if (GCC_OPTION (flag_indirect_dispatch))
     {
       abi_version = GCJ_CURRENT_BC_ABI_VERSION;
       abi_version |= FLAG_BINARYCOMPAT_ABI;
@@ -547,7 +547,7 @@ parse_version (void)
 	 4.0.1).  */
       abi_version = 100000 * major + 1000 * minor;
     }
-  if (flag_bootstrap_classes)
+  if (GCC_OPTION (flag_bootstrap_classes))
     abi_version |= FLAG_BOOTSTRAP_LOADER;
 
   gcj_abi_version = build_int_cstu (ptr_type_node, abi_version);
@@ -802,7 +802,7 @@ java_init_decl_processing (void)
   /* This isn't exactly true, but it is what we have in the source.
      There is an unresolved issue here, which is whether the vtable
      should be marked by the GC.  */
-  if (! flag_hash_synchronization)
+  if (! GCC_OPTION (flag_hash_synchronization))
     PUSH_FIELD (input_location, object_type_node, field, "sync_info",
 		build_pointer_type (object_type_node));
   for (t = TYPE_FIELDS (object_type_node); t != NULL_TREE; t = DECL_CHAIN (t))
@@ -1626,7 +1626,7 @@ force_poplevels (int start_pc)
 {
   while (current_binding_level->start_pc > start_pc)
     {
-      if (pedantic && current_binding_level->start_pc > start_pc)
+      if (GCC_OPTION (pedantic) && current_binding_level->start_pc > start_pc)
 	warning (0, "In %+D: overlapped variable and exception ranges at %d",
                  current_function_decl,
 		 current_binding_level->start_pc);
@@ -1962,7 +1962,7 @@ java_mark_class_local (tree klass)
   for (t = TYPE_METHODS (klass); t ; t = DECL_CHAIN (t))
     if (!METHOD_ABSTRACT (t))
       {
-	if (METHOD_NATIVE (t) && !flag_jni)
+	if (METHOD_NATIVE (t) && !GCC_OPTION (flag_jni))
 	  java_mark_cni_decl_local (t);
         else
 	  java_mark_decl_local (t);
diff --git a/gcc/java/except.c b/gcc/java/except.c
index 47c76e8..d0f53aa 100644
--- a/gcc/java/except.c
+++ b/gcc/java/except.c
@@ -388,7 +388,7 @@ prepare_eh_table_type (tree type)
   if (*slot != NULL)
     return TREE_VALUE (*slot);
 
-  if (is_compiled_class (type) && !flag_indirect_dispatch)
+  if (is_compiled_class (type) && !GCC_OPTION (flag_indirect_dispatch))
     {
       name = IDENTIFIER_POINTER (DECL_NAME (TYPE_NAME (type)));
       buf = (char *) alloca (strlen (name) + 5);
@@ -576,7 +576,7 @@ check_start_handlers (struct eh_range *range, int pc)
 static inline int
 doing_eh (void)
 {
-  if (! flag_exceptions)
+  if (! GCC_OPTION (flag_exceptions))
     {
       static int warned = 0;
       if (! warned)
diff --git a/gcc/java/expr.c b/gcc/java/expr.c
index 69f6819..3ae664f 100644
--- a/gcc/java/expr.c
+++ b/gcc/java/expr.c
@@ -351,7 +351,7 @@ pop_type_0 (tree type, char **messagep)
       return type;
     }
 
-  if (! flag_verify_invocations && flag_indirect_dispatch
+  if (! flag_verify_invocations && GCC_OPTION (flag_indirect_dispatch)
       && t == object_ptr_type_node)
     {
       if (type != ptr_type_node)
@@ -502,7 +502,7 @@ can_widen_reference_to (tree source_type, tree target_type)
       add_type_assertion (current_class, JV_ASSERT_TYPES_COMPATIBLE, 
 			  source_type, target_type);
 
-      if (!quiet_flag)
+      if (!GCC_OPTION (quiet_flag))
        warning (0, "assert: %s is assign compatible with %s", 
 		xstrdup (lang_printable_name (target_type, 0)),
 		xstrdup (lang_printable_name (source_type, 0)));
@@ -549,7 +549,7 @@ can_widen_reference_to (tree source_type, tree target_type)
 
 	  if (TYPE_DUMMY (source_type) || TYPE_DUMMY (target_type))
 	    {
-	      if (! quiet_flag)
+	      if (! GCC_OPTION (quiet_flag))
 		warning (0, "assert: %s is assign compatible with %s", 
 			 xstrdup (lang_printable_name (target_type, 0)),
 			 xstrdup (lang_printable_name (source_type, 0)));
@@ -830,7 +830,7 @@ build_java_array_length_access (tree node)
 
   node = build3 (COMPONENT_REF, int_type_node,
 		 build_java_indirect_ref (array_type, node,
-					  flag_check_references),
+					  GCC_OPTION (flag_check_references)),
 		 lookup_field (&array_type, get_identifier ("length")),
 		 NULL_TREE);
   IS_ARRAY_LENGTH_ACCESS (node) = 1;
@@ -844,7 +844,7 @@ build_java_array_length_access (tree node)
 tree 
 java_check_reference (tree expr, int check)
 {
-  if (!flag_syntax_only && check)
+  if (!GCC_OPTION (flag_syntax_only) && check)
     {
       expr = save_expr (expr);
       expr = build3 (COND_EXPR, TREE_TYPE (expr),
@@ -891,7 +891,7 @@ build_java_arrayaccess (tree array, tree type, tree index)
       array_type = build_java_array_type (type, -1);
     }
 
-  if (flag_bounds_check)
+  if (GCC_OPTION (flag_bounds_check))
     {
       /* Generate:
        * (unsigned jint) INDEX >= (unsigned jint) LEN
@@ -923,7 +923,7 @@ build_java_arrayaccess (tree array, tree type, tree index)
 
   ref = build3 (COMPONENT_REF, TREE_TYPE (data_field),    
 		build_java_indirect_ref (array_type, array, 
-					 flag_check_references),
+					 GCC_OPTION (flag_check_references)),
 		data_field, NULL_TREE);
 
   /* Take the address of the data field and convert it to a pointer to
@@ -976,7 +976,7 @@ build_java_arraystore_check (tree array, tree object)
   gcc_assert (TREE_CODE (element_type) == TYPE_DECL
 	      && TREE_CODE (object_type) == TYPE_DECL);
 
-  if (!flag_store_check)
+  if (!GCC_OPTION (flag_store_check))
     return build1 (NOP_EXPR, array_type_p, array);
 
   /* No check is needed if the element type is final.  Also check that
@@ -985,7 +985,7 @@ build_java_arraystore_check (tree array, tree object)
      the array rather than its declared type.  However, if we're doing
      indirect dispatch, we can't do the `final' optimization.  */
   if (element_type == object_type
-      && ! flag_indirect_dispatch
+      && ! GCC_OPTION (flag_indirect_dispatch)
       && CLASS_FINAL (element_type))
     return build1 (NOP_EXPR, array_type_p, array);
   
@@ -1372,7 +1372,7 @@ build_get_class (tree value)
 				    get_identifier ("vtable"));
   tree tmp = build3 (COMPONENT_REF, dtable_ptr_type,
 		     build_java_indirect_ref (object_type_node, value,
-					      flag_check_references),
+					      GCC_OPTION (flag_check_references)),
 		     vtable_field, NULL_TREE);
   return build3 (COMPONENT_REF, class_ptr_type,
 		 build1 (INDIRECT_REF, dtable_type, tmp),
@@ -1586,8 +1586,8 @@ build_java_binop (enum tree_code op, tree type, tree arg1, tree arg2)
 	}
       
       if (TREE_CODE (type) == INTEGER_TYPE
-	  && flag_use_divide_subroutine
-	  && ! flag_syntax_only)
+	  && GCC_OPTION (flag_use_divide_subroutine)
+	  && ! GCC_OPTION (flag_syntax_only))
 	return build_java_soft_divmod (op, type, arg1, arg2);
       
       break;
@@ -1711,8 +1711,8 @@ build_field_ref (tree self_value, tree self_class, tree name)
 	 memory may be allocated from any other page, so only field
 	 offsets < pagesize are guaranteed to trap.  We also assume
 	 the smallest page size we'll encounter is 4k bytes.  */
-      if (! flag_syntax_only && check && ! flag_check_references 
-	  && ! flag_indirect_dispatch)
+      if (! GCC_OPTION (flag_syntax_only) && check && ! GCC_OPTION (flag_check_references) 
+	  && ! GCC_OPTION (flag_indirect_dispatch))
 	{
 	  tree field_offset = byte_position (field_decl);
 	  if (! page_size)
@@ -1722,7 +1722,7 @@ build_field_ref (tree self_value, tree self_class, tree name)
 
       if (base_type != TREE_TYPE (self_value))
 	self_value = fold_build1 (NOP_EXPR, base_type, self_value);
-      if (! flag_syntax_only && flag_indirect_dispatch)
+      if (! GCC_OPTION (flag_syntax_only) && GCC_OPTION (flag_indirect_dispatch))
 	{
 	  tree otable_index
 	    = build_int_cst (NULL_TREE, get_symbol_table_index 
@@ -2195,7 +2195,7 @@ build_known_method_ref (tree method, tree method_type ATTRIBUTE_UNUSED,
 	 publicly visible methods or gcc will use PLT indirections
 	 to reach them.  We also have to use indirect dispatch for all
 	 external methods.  */
-      if (! flag_indirect_dispatch 
+      if (! GCC_OPTION (flag_indirect_dispatch) 
 	  || (! DECL_EXTERNAL (method) && ! TREE_PUBLIC (method)))
 	{
 	  func = build1 (ADDR_EXPR, build_pointer_type (TREE_TYPE (method)),
@@ -2279,7 +2279,7 @@ invoke_build_dtable (int is_invoke_interface, vec<tree, va_gc> *arg_list)
   if (dtable_ident == NULL_TREE)
     dtable_ident = get_identifier ("vtable");
   dtable = build_java_indirect_ref (object_type_node, objectref, 
-				    flag_check_references);
+				    GCC_OPTION (flag_check_references));
   dtable = build3 (COMPONENT_REF, dtable_ptr_type, dtable,
 		   lookup_field (&object_type_node, dtable_ident), NULL_TREE);
 
@@ -2318,7 +2318,7 @@ build_invokevirtual (tree dtable, tree method, tree special)
   tree method_index;
   tree otable_index;
 
-  if (flag_indirect_dispatch)
+  if (GCC_OPTION (flag_indirect_dispatch))
     {
       gcc_assert (! CLASS_INTERFACE (TYPE_NAME (DECL_CONTEXT (method))));
 
@@ -2370,7 +2370,7 @@ build_invokeinterface (tree dtable, tree method)
     class_ident = get_identifier ("class");
 
   dtable = build_java_indirect_ref (dtable_type, dtable,
-				    flag_check_references);
+				    GCC_OPTION (flag_check_references));
   dtable = build3 (COMPONENT_REF, class_ptr_type, dtable,
 		   lookup_field (&dtable_type, class_ident), NULL_TREE);
 
@@ -2378,7 +2378,7 @@ build_invokeinterface (tree dtable, tree method)
   gcc_assert (CLASS_INTERFACE (TYPE_NAME (interface)));
   layout_class_methods (interface);
   
-  if (flag_indirect_dispatch)
+  if (GCC_OPTION (flag_indirect_dispatch))
     {
       int itable_index 
 	= 2 * (get_symbol_table_index 
@@ -2478,7 +2478,7 @@ expand_invoke (int opcode, int method_ref_index, int nargs ATTRIBUTE_UNUSED)
 
   if (method == NULL_TREE)
     {
-      if (flag_verify_invocations || ! flag_indirect_dispatch)
+      if (flag_verify_invocations || ! GCC_OPTION (flag_indirect_dispatch))
 	{
 	  error ("class '%s' has no method named '%s' matching signature '%s'",
 		 self_name,
@@ -2629,7 +2629,7 @@ build_jni_stub (tree method)
   tree klass = DECL_CONTEXT (method);
   klass = build_class_ref (klass);
 
-  gcc_assert (METHOD_NATIVE (method) && flag_jni);
+  gcc_assert (METHOD_NATIVE (method) && GCC_OPTION (flag_jni));
 
   DECL_ARTIFICIAL (method) = 1;
   DECL_EXTERNAL (method) = 0;
@@ -2904,7 +2904,7 @@ expand_java_field_op (int is_static, int is_putting, int field_ref_index)
 
   field_ref = build_field_ref (field_ref, self_type, field_name);
   if (is_static
-      && ! flag_indirect_dispatch)
+      && ! GCC_OPTION (flag_indirect_dispatch))
     {
       tree context = DECL_CONTEXT (field_ref);
       if (context != self_type && CLASS_INTERFACE (TYPE_NAME (context)))
@@ -3195,7 +3195,7 @@ expand_byte_code (JCF *jcf, tree method)
 	  if (dead_code_index != -1)
 	    {
               /* We've just reached the end of a region of dead code.  */
-	      if (extra_warnings)
+	      if (GCC_OPTION (extra_warnings))
 		warning (0, "unreachable bytecode from %d to before %d",
 			 dead_code_index, PC);
               dead_code_index = -1;
@@ -3237,7 +3237,7 @@ expand_byte_code (JCF *jcf, tree method)
   if (dead_code_index != -1)
     {
       /* We've just reached the end of a region of dead code.  */
-      if (extra_warnings)
+      if (GCC_OPTION (extra_warnings))
 	warning (0, "unreachable bytecode from %d to the end of the method", 
 		 dead_code_index);
     }
@@ -3727,10 +3727,10 @@ promote_arguments (void)
 static void
 cache_cpool_data_ref (void)
 {
-  if (optimize)
+  if (GCC_OPTION (optimize))
     {
       tree cpool;
-      tree d = build_constant_data_ref (flag_indirect_classes);
+      tree d = build_constant_data_ref (GCC_OPTION (flag_indirect_classes));
       tree cpool_ptr = build_decl (input_location, VAR_DECL, NULL_TREE, 
 				   build_pointer_type (TREE_TYPE (d)));
       java_add_local_var (cpool_ptr);
diff --git a/gcc/java/java-tree.h b/gcc/java/java-tree.h
index 806d2d7..6712e48 100644
--- a/gcc/java/java-tree.h
+++ b/gcc/java/java-tree.h
@@ -1483,7 +1483,7 @@ extern tree *type_map;
 
 /* True when we can perform static class initialization optimization */
 #define STATIC_CLASS_INIT_OPT_P() \
-  (flag_optimize_sci && (optimize >= 2))
+  (GCC_OPTION (flag_optimize_sci) && (GCC_OPTION (optimize) >= 2))
 
 /* These are the possible values for the `state' field of the class
    structure.  This must be kept in sync with libgcj.  */
diff --git a/gcc/java/jcf-parse.c b/gcc/java/jcf-parse.c
index afe35f0..2664c5d 100644
--- a/gcc/java/jcf-parse.c
+++ b/gcc/java/jcf-parse.c
@@ -356,7 +356,7 @@ set_source_filename (JCF *jcf, int index)
       
   sfname = find_sourcefile (sfname);
   ORDINARY_MAP_FILE_NAME (LINEMAPS_LAST_ORDINARY_MAP (line_table)) = sfname;
-  if (current_class == main_class) main_input_filename = sfname;
+  if (current_class == main_class) GCC_OPTION (main_input_filename) = sfname;
 }
 
 
@@ -1200,8 +1200,8 @@ give_name_to_class (JCF *jcf, int i)
       input_location = linemap_line_start (line_table, 0, 1);
       file_start_location = input_location;
       DECL_SOURCE_LOCATION (TYPE_NAME (this_class)) = input_location;
-      if (main_input_filename == NULL && jcf == main_jcf)
-	main_input_filename = sfname;
+      if (GCC_OPTION (main_input_filename) == NULL && jcf == main_jcf)
+	GCC_OPTION (main_input_filename) = sfname;
       }
 
       jcf->cpool.data[i].t = this_class;
@@ -1391,7 +1391,7 @@ load_class (tree class_or_name, int verbose)
   
   if (!class_loaded)
     {
-      if (flag_verify_invocations || ! flag_indirect_dispatch)
+      if (flag_verify_invocations || ! GCC_OPTION (flag_indirect_dispatch))
 	{
 	  if (verbose)
 	    error ("cannot find file for class %s", IDENTIFIER_POINTER (saved));
@@ -1399,7 +1399,7 @@ load_class (tree class_or_name, int verbose)
       else if (verbose)
 	{
 	  /* This is just a diagnostic during testing, not a real problem.  */
-	  if (!quiet_flag)
+	  if (!GCC_OPTION (quiet_flag))
 	    warning (0, "cannot find file for class %s", 
 		     IDENTIFIER_POINTER (saved));
 	  
@@ -1436,7 +1436,7 @@ jcf_parse (JCF* jcf)
   jcf_parse_class (jcf);
   if (main_class == NULL_TREE)
     main_class = current_class;
-  if (! quiet_flag && TYPE_NAME (current_class))
+  if (! GCC_OPTION (quiet_flag) && TYPE_NAME (current_class))
     fprintf (stderr, " %s %s",
 	     (jcf->access_flags & ACC_INTERFACE) ? "interface" : "class", 
 	     IDENTIFIER_POINTER (DECL_NAME (TYPE_NAME (current_class))));
@@ -1581,7 +1581,7 @@ parse_class_file (void)
 	  tree arg;
 	  int  decl_max_locals;
 
-	  if (! flag_jni)
+	  if (! GCC_OPTION (flag_jni))
 	    continue;
 	  /* We need to compute the DECL_MAX_LOCALS. We need to take
              the wide types into account too. */
@@ -1746,10 +1746,10 @@ java_parse_file (void)
   bitmap_obstack_initialize (&bit_obstack);
   field_offsets = BITMAP_ALLOC (&bit_obstack);
 
-  if (flag_filelist_file)
+  if (GCC_OPTION (flag_filelist_file))
     {
       int avail = 2000;
-      finput = fopen (main_input_filename, "r");
+      finput = fopen (GCC_OPTION (main_input_filename), "r");
       if (finput == NULL)
 	fatal_error ("can%'t open %s: %m", LOCATION_FILE (input_location));
       list = XNEWVEC (char, avail);
@@ -1783,14 +1783,14 @@ java_parse_file (void)
       file_list = list;
     }
   else
-    list = CONST_CAST (char *, main_input_filename);
+    list = CONST_CAST (char *, GCC_OPTION (main_input_filename));
 
   while (list)
     {
       for (next = list; ; )
 	{
 	  char ch = *next;
-	  if (flag_filelist_file && ! in_quotes
+	  if (GCC_OPTION (flag_filelist_file) && ! in_quotes
 	      && (ch == '\n' || ch == '\r' || ch == '\t' || ch == ' '
 		  || ch == '&') /* FIXME */)
 	    {
@@ -1806,7 +1806,7 @@ java_parse_file (void)
 		  break;
 		}
 	    }
-	  if (flag_filelist_file && ch == '"')
+	  if (GCC_OPTION (flag_filelist_file) && ch == '"')
 	    {
 	      in_quotes = ! in_quotes;
 	      *next++ = '\0';
@@ -1885,7 +1885,7 @@ java_parse_file (void)
 
       /* Close previous descriptor, if any */
       if (finput && fclose (finput))
-	fatal_error ("can%'t close input file %s: %m", main_input_filename);
+	fatal_error ("can%'t close input file %s: %m", GCC_OPTION (main_input_filename));
       
       finput = fopen (filename, "rb");
       if (finput == NULL)
@@ -1962,7 +1962,7 @@ java_parse_file (void)
 	  /* FIXME: These two flags really should be independent.  We
 	     should be able to compile fully binary compatible, but
 	     with flag_verify_invocations on.  */
-	  flag_verify_invocations = ! flag_indirect_dispatch;
+	  flag_verify_invocations = ! GCC_OPTION (flag_indirect_dispatch);
 	  output_class = current_class = TREE_TYPE (node);
 
 	  current_jcf = TYPE_JCF (current_class);
diff --git a/gcc/java/jcf.h b/gcc/java/jcf.h
index 8aa077e..913a891 100644
--- a/gcc/java/jcf.h
+++ b/gcc/java/jcf.h
@@ -292,7 +292,7 @@ extern const char *jcf_write_base_directory;
 #ifdef VERBOSE_SKELETON
 #undef SOURCE_FRONTEND_DEBUG
 #define SOURCE_FRONTEND_DEBUG(X)				\
-  {if (!quiet_flag) {printf ("* "); printf X; putchar ('\n');} }
+  {if (!GCC_OPTION (quiet_flag)) {printf ("* "); printf X; putchar ('\n');} }
 #else
 #define SOURCE_FRONTEND_DEBUG(X)
 #endif
